{ TC-08 DEMO program for Delphi }

unit USBTc08fm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Start: TButton;
    Timer1: TTimer;
    Stop: TButton;
    Label2: TLabel;
    Label3: TLabel;
    lbChannel1: TLabel;
    lbChannel2: TLabel;
    Label7: TLabel;
    lbCJC: TLabel;
    lbStatus: TLabel;
    procedure StartClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure StopClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  in_timer : Boolean;
  tc08_handle : smallint;



implementation
{$I USBTC08.INC}

{$R *.DFM}

procedure TForm1.StartClick(Sender: TObject);
var
  ok          : boolean;
  s           : string;
  error_code  : smallint;
  ascii       : smallint;
begin
  if (tc08_handle < 1) then
    begin
      lbStatus.caption := 'Opening TC08';
      repaint;
      tc08_handle := usb_tc08_open_unit ();

      if (tc08_handle > 0) then
        begin
          lbStatus.caption := 'Opened TC08';
          usb_tc08_set_mains (tc08_handle, true);
          ascii := 107;  // ascii value for character k
          ok := usb_tc08_set_channel(tc08_handle, 0, ascii);
          if ok then ok :=false;
          ok := usb_tc08_set_channel(tc08_handle, 1, ascii);
          if ok then  ok:=false;
          ok := usb_tc08_set_channel(tc08_handle, 2, ascii);
          if ok then ok:=false;
        end
      else
        begin
          if (tc08_handle = 0) then
            begin
              lbStatus.caption := 'Unable to open USB TC-08';
            end
          else
            begin
              error_code := usb_tc08_get_last_error(0);
              Str (error_code:1, s);
              lbStatus.caption := 'Error: ' + s;
            end
        end
    end;
    Repaint;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  temp_buffer  : array [1..9] of single;
  var  overflow     : smallint;
  ok           : boolean;
  s            : string[6];

begin
if (tc08_handle > 0) then
  begin
    if (not in_timer) then
      begin
        in_timer := true;
        ok := usb_tc08_get_single (tc08_handle, temp_buffer, overflow,0);
        if ok then
          begin
            Str (temp_buffer[1]: 6:2, s);
            lbCJC.Caption := s  + 'C';

            Str (temp_buffer[2]: 6:2, s);
            lbChannel1.Caption := s  + 'C';

            Str (temp_buffer[3]: 6:2, s);
            lbChannel2.Caption := s  + 'C';
          end;
        in_timer := false;
      end
  end
end;

procedure TForm1.StopClick(Sender: TObject);
begin
if (tc08_handle > 0) then
  begin
    usb_tc08_close_unit (tc08_handle);

    tc08_handle := -1;
    lbStatus.caption := 'Stopped';
  end
else
  begin
    lbStatus.caption := 'TC08 is not running';
  end;

end;


end.
